Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -2204,74 +3225,254 @@
                 // multi_write_buffer access is conditionnal with dcache_miss_req and icache_miss_req
 
-#if   (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==1)
-                //  1) two access authorized
-                bool dcache_miss_req =  r_dcache_miss_req;
-                bool icache_miss_req =  r_icache_miss_req;
-#elif (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==2)
-                //  2) one access with static priority (dcache prior)
-                bool dcache_miss_req = r_dcache_miss_req; // dcache prior
-                bool icache_miss_req = not dcache_miss_req and r_icache_miss_req;
+                bool     dcache_miss_req      = false;
+                bool     icache_miss_req      = false;
+                uint32_t dcache_miss_num_cache = 0;
+                uint32_t icache_miss_num_cache = 0;
+                addr_40  addr = 0;
+
+                {
+                    for (; dcache_miss_num_cache<m_nb_dcache; ++dcache_miss_num_cache)
+                    {
+                        dcache_miss_req = r_dcache_miss_req[dcache_miss_num_cache];
+                        if (dcache_miss_req)
+                            break;
+                    }
+                    for (; icache_miss_num_cache<m_nb_icache; ++icache_miss_num_cache)
+                    {
+                        icache_miss_req = r_icache_miss_req[icache_miss_num_cache];
+                        if (icache_miss_req)
+                            break;
+                    }
+
+                    PRINTF("      * <CMD> icache_miss_req (before) : %d\n",icache_miss_req);
+                    PRINTF("      * <CMD> dcache_miss_req (before) : %d\n",dcache_miss_req);
+
+// #if   (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==1)
+//                     //  1) two access authorized
+//                     dcache_miss_req =  r_dcache_miss_req[cache_miss_num_cache];
+//                     icache_miss_req =  r_icache_miss_req[cache_miss_num_cache];
+// #el
+#if   (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==2)
+                    //  2) one access with static priority (dcache prior)
+                    icache_miss_req &= not dcache_miss_req;
 #elif (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==3)
-                //  3) one access with static priority (icache prior)
-                bool icache_miss_req = r_icache_miss_req;
-                bool dcache_miss_req = not icache_miss_req and r_dcache_miss_req; // dcache prior
+                    //  3) one access with static priority (icache prior)
+                    dcache_miss_req &= not icache_miss_req;
 #elif (CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY==4)
-                //  4) one access with round robin priority
-                bool dcache_miss_req = ((r_dcache_miss_req and not r_icache_miss_req) or // only dcache
-                                        (r_dcache_miss_req and r_vci_cmd_dcache_prior)); // dcache prior
-                bool icache_miss_req = not dcache_miss_req and r_icache_miss_req;
+                    //  4) one access with round robin priority
+                    dcache_miss_req = ((dcache_miss_req and not icache_miss_req) or // only dcache
+                                       (dcache_miss_req and r_vci_cmd_dcache_prior)); // dcache prior
+                    icache_miss_req &= not dcache_miss_req;
 #else
 #error "Invalid value to CC_XCACHE_WRAPPER_VCI_CMD_PRIORITY"
 #endif
+
+                    PRINTF("      * <CMD> icache_miss_req (after ) : %d\n",icache_miss_req);
+                    PRINTF("      * <CMD> dcache_miss_req (after ) : %d\n",dcache_miss_req);
+
+                    PRINTF("      * <CMD> icache_miss_num_cache    : %d\n",icache_miss_num_cache);
+                    PRINTF("      * <CMD> dcache_miss_num_cache    : %d\n",dcache_miss_num_cache);
+
+                    if (icache_miss_req or dcache_miss_req)
+                    {
+                        addr = (icache_miss_req)?r_icache_addr_save[icache_miss_num_cache].read():r_dcache_addr_save[dcache_miss_num_cache].read();
+
+                        PRINTF("      * <CMD> addr                     : %llx\n",(uint64_t)addr);
+
+                        if (icache_miss_req)
+                        {
+                            // FIXME : 
+                            // si wbuf contient des addresses partionné, set_num_icache puis get_num_dcache
+                            // dcache_miss_num_cache = icache_miss_num_cache;
+                            set_num_icache(addr,icache_miss_num_cache);
+                            // get_num_dcache(addr,dcache_miss_num_cache);
+                        }
+                        else
+                            set_num_dcache(addr,dcache_miss_num_cache);
+
+                        PRINTF("      * <CMD> addr                     : %llx\n",(uint64_t)addr);
+                    }
+                }
+
+                uint32_t dcache_unc_num_cache = 0;
+                for (; dcache_unc_num_cache<m_nb_dcache; ++dcache_unc_num_cache)
+                    if (r_dcache_unc_req[dcache_unc_num_cache])
+                        break;
+                uint32_t icache_unc_num_cache = 0;
+                for (; icache_unc_num_cache<m_nb_icache; ++icache_unc_num_cache)
+                    if (r_icache_unc_req[icache_unc_num_cache])
+                        break;
+                uint32_t dcache_sc_num_cache = 0;
+                for (; dcache_sc_num_cache<m_nb_dcache; ++dcache_sc_num_cache)
+                    if (r_dcache_sc_req[dcache_sc_num_cache])
+                        break;
+                uint32_t dcache_write_num_cache = 0;
+                for (; dcache_write_num_cache<m_nb_dcache; ++dcache_write_num_cache)
+                {
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    if ( r_wbuf[dcache_write_num_cache]->debug_rok(&wbuf_min, &wbuf_max, &wbuf_addr, &wbuf_index))
+                        break;
+#else
+                    if ( r_wbuf[dcache_write_num_cache]->rok(&wbuf_min, &wbuf_max))
+                        break;
+#endif
+                }
+                
                 // 1 - Data Read
-                if (dcache_miss_req and r_wbuf.miss(r_dcache_addr_save))
+                if (dcache_miss_req and r_wbuf[dcache_miss_num_cache]->miss(addr))
                 { 
-                    r_vci_cmd_fsm = CMD_DATA_MISS;
-                    r_dcache_miss_req = false;
+                    r_vci_cmd_fsm       = CMD_DATA_MISS;
+                    r_vci_cmd_num_cache = dcache_miss_num_cache;
+                    r_dcache_miss_req[dcache_miss_num_cache] = false;
                     m_cpt_dmiss_transaction++; 
+
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD DATA MISS  "
+                            << "(" << dcache_miss_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_dcache_yzmask) << ")"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
                 } 
 
                 // 2 - Data Read Uncachable
-                else if ( r_dcache_unc_req )
+                else if (dcache_unc_num_cache < m_nb_dcache) // have r_dcache_unc_req
                 { 
-                    r_vci_cmd_fsm = CMD_DATA_UNC;
-                    r_dcache_unc_req = false;
-                 // m_cpt_data_unc_transaction++; 
+                    r_vci_cmd_fsm       = CMD_DATA_UNC;
+                    r_vci_cmd_num_cache = dcache_unc_num_cache;
+                    r_dcache_unc_req[dcache_unc_num_cache] = false;
+                    // m_cpt_data_unc_transaction++; 
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        addr_40 addr = (addr_40) r_dcache_addr_save[dcache_unc_num_cache].read() & ~0x3;
+                        set_num_dcache(addr,dcache_unc_num_cache);
+                        
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD DATA UNC   "
+                            << "(" << dcache_unc_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_dcache_yzmask) << ")"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                 }
 
                 // 3 - Instruction Miss
-                else if (icache_miss_req and r_wbuf.miss(r_icache_addr_save))
+                else if (icache_miss_req and r_wbuf[icache_miss_num_cache]->miss(addr))
+              //else if (icache_miss_req and r_wbuf[dcache_miss_num_cache]->miss(addr))
                 { 
-                    r_vci_cmd_fsm = CMD_INS_MISS; 
-                    r_icache_miss_req = false;
+                    r_vci_cmd_fsm       = CMD_INS_MISS; 
+                    r_vci_cmd_num_cache = icache_miss_num_cache;
+                    r_icache_miss_req[icache_miss_num_cache] = false;
                     m_cpt_imiss_transaction++;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD INS  MISS  "
+                            << "(" << icache_miss_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_icache_yzmask) << ")"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                 } 
 
                 // 4 - Instruction Uncachable
-                else if ( r_icache_unc_req )
+                else if (icache_unc_num_cache < m_nb_icache) // have r_icache_unc_req
                 { 
-                    r_vci_cmd_fsm = CMD_INS_UNC; 
-                    r_icache_unc_req = false;
+                    r_vci_cmd_fsm       = CMD_INS_UNC; 
+                    r_vci_cmd_num_cache = icache_unc_num_cache;
+                    r_icache_unc_req[icache_unc_num_cache] = false;
                  // m_cpt_ins_unc_transaction++;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        addr_40 addr = (addr_40) r_icache_addr_save[icache_unc_num_cache].read() & ~0x3;
+                        set_num_dcache(addr,icache_unc_num_cache);
+                        
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD INS  UNC   "
+                            << "(" << icache_unc_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_icache_yzmask) << ")"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                 }
 
                 // 5 - Data Write
-                else if ( r_wbuf.rok(&min, &max) ) 
+                else if (dcache_write_num_cache < m_nb_dcache) // have r_wbuf.rok(&wbuf_min, &wbuf_max)
                 { 
-                    r_vci_cmd_fsm = CMD_DATA_WRITE;
-                    r_vci_cmd_cpt = min;
-                    r_vci_cmd_min = min;
-                    r_vci_cmd_max = max;
+                    r_vci_cmd_num_cache = dcache_write_num_cache;
+                    r_vci_cmd_fsm       = CMD_DATA_WRITE;
+                    r_vci_cmd_cpt       = wbuf_min;
+                    r_vci_cmd_min       = wbuf_min;
+                    r_vci_cmd_max       = wbuf_max;
                     m_cpt_data_write_transaction++; 
-                    m_length_write_transaction += (max-min+1); 
+                    m_length_write_transaction += (wbuf_max-wbuf_min+1); 
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        addr_40 addr = (addr_40) wbuf_addr&~0x3;
+                        
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD DATA WRITE "
+                            << "(" << dcache_write_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_dcache_yzmask) << ")"
+                            << " [" << wbuf_min << ":" << wbuf_max << "]"
+                            << " {" << wbuf_index << "}"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                 } 
 
                 // 6 - Data Store Conditionnal
-                else if ( r_dcache_sc_req ) 
+                else if (dcache_sc_num_cache < m_nb_dcache) // have r_dcache_sc_req
                 { 
-                    r_vci_cmd_fsm = CMD_DATA_SC;
-                    r_vci_cmd_max = 1; 
+                    r_vci_cmd_fsm       = CMD_DATA_SC;
+                    r_vci_cmd_num_cache = dcache_sc_num_cache;
+                    r_vci_cmd_max       = 1; 
                     m_cpt_unc_transaction++; 
-                    r_dcache_sc_req = false;
+                    r_dcache_sc_req[dcache_sc_num_cache] = false;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    {
+                        addr_40 addr = (addr_40) r_dcache_addr_save[dcache_sc_num_cache].read() & ~0x3;
+                        set_num_dcache(addr,dcache_sc_num_cache);
+                        
+                        log_transaction_file_cmd
+                            << "[" << m_cpt_total_cycles << "] "
+                            << "CMD DATA SC    "
+                            << "(" << dcache_sc_num_cache << ") "
+                            << std::hex
+                            << " @ " << std::setw(10) << (uint64_t)addr
+                            << " (L " << std::setw(10) << ((uint64_t)addr&(uint64_t)m_dcache_yzmask) << ")"
+                            << std::dec
+                            << std::endl;
+                    }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
                 }
 
@@ -2283,5 +3484,5 @@
                     if (r_vci_cmd_cpt == r_vci_cmd_max) {
                         r_vci_cmd_fsm = CMD_IDLE ;
-                        r_wbuf.sent() ;
+                        r_wbuf[r_vci_cmd_num_cache]->sent() ;
                     }
                 }
@@ -2339,19 +3540,110 @@
                 if( p_vci_ini_rw.rspval.read() )
                 {
-                    PRINTF("      * <RSP> have rsp - trdid : %x\n",(uint32_t)p_vci_ini_rw.rtrdid.read());
+                    PRINTF("      * <RSP> have rsp - trdid : %x - num_cache : %d\n",(uint32_t)p_vci_ini_rw.rtrdid.read(),(uint32_t)p_vci_ini_rw.rpktid.read());
+
+                    ASSERT(p_vci_ini_rw.rpktid.read() <= (1<<vci_param::P),
+                           "invalid pktid in a cleanup response");
 
                     r_vci_rsp_cpt = 0;
 
                     if ((p_vci_ini_rw.rtrdid.read()>>(vci_param::T-1)) != 0 )
+                    {
                         r_vci_rsp_fsm = RSP_DATA_WRITE;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                        {
+                            log_transaction_file_cmd
+                                << "[" << m_cpt_total_cycles << "] "
+                                << "RSP DATA WRITE "
+                                << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                << "{" << (p_vci_ini_rw.rtrdid.read() - (1<<(vci_param::T-1))) << "}"
+                                << std::endl;
+                        }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    }
                     else
                     {
                         switch (p_vci_ini_rw.rtrdid.read())
                         {
-                        case TYPE_INS_MISS     : r_vci_rsp_fsm = RSP_INS_MISS;     break;
-                        case TYPE_INS_UNC      : r_vci_rsp_fsm = RSP_INS_UNC;      break;
-                        case TYPE_DATA_MISS    : r_vci_rsp_fsm = RSP_DATA_MISS;    break;
-                        case TYPE_DATA_UNC     : r_vci_rsp_fsm = RSP_DATA_UNC;     break;
-                        case TYPE_DATA_SC      : r_vci_rsp_fsm = RSP_DATA_SC;      break;
+                        case TYPE_INS_MISS     : 
+                            {
+                                r_vci_rsp_fsm = RSP_INS_MISS;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_cmd
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "RSP INS  MISS  "
+                                        << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
+                                break;
+                            }
+                        case TYPE_INS_UNC      : 
+                            {
+                                r_vci_rsp_fsm = RSP_INS_UNC;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_cmd
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "RSP INS  UNC   "
+                                        << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
+                                break;
+                            }
+                        case TYPE_DATA_MISS    : 
+                            {
+                                r_vci_rsp_fsm = RSP_DATA_MISS;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_cmd
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "RSP DATA MISS  "
+                                        << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
+                                break;
+                            }
+                        case TYPE_DATA_UNC     : 
+                            {
+                                r_vci_rsp_fsm = RSP_DATA_UNC;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_cmd
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "RSP DATA UNC   "
+                                        << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
+                                break;
+                            }
+                        case TYPE_DATA_SC      : 
+                            {
+                                r_vci_rsp_fsm = RSP_DATA_SC;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                                {
+                                    log_transaction_file_cmd
+                                        << "[" << m_cpt_total_cycles << "] "
+                                        << "RSP DATA SC    "
+                                        << "(" << p_vci_ini_rw.rpktid.read() << ") "
+                                        << std::endl;
+                                }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
+                                break;
+                            }
                         default : 
                             {
@@ -2360,4 +3652,6 @@
                         }
                     }
+
+                    r_vci_rsp_num_cache = p_vci_ini_rw.rpktid.read();
                 }
                 break;
@@ -2366,7 +3660,7 @@
 
                 m_cost_imiss_transaction++;
-                PRINTF("      * <RSP> rspval/ack : %d - %d\n",(uint32_t)p_vci_ini_rw.rspval.read(), (uint32_t)r_vci_rsp_ack);
-
-                if (p_vci_ini_rw.rspval.read() and r_vci_rsp_ack)
+                PRINTF("      * <RSP> rspval/ack : %d - %d\n",(uint32_t)p_vci_ini_rw.rspval.read(), (uint32_t)s_vci_rsp_ack);
+
+                if (p_vci_ini_rw.rspval.read() and s_vci_rsp_ack)
                 {
                     PRINTF("      * <RSP> have rsp - r_vci_rsp_cpt : %d/%d\n",(uint32_t)r_vci_rsp_cpt.read(),(uint32_t)m_icache_words);
@@ -2376,5 +3670,5 @@
                             "The VCI response packet for instruction miss is too long" );
                     r_vci_rsp_cpt = r_vci_rsp_cpt + 1;
-                    CACHE_MISS_BUF_RSP_PUSH(i,r_vci_rsp_cpt,(data_t)p_vci_ini_rw.rdata.read());
+                    CACHE_MISS_BUF_RSP_PUSH(i,r_vci_rsp_num_cache,r_vci_rsp_cpt,(data_t)p_vci_ini_rw.rdata.read());
                     if ( p_vci_ini_rw.reop.read() ) 
                     {
@@ -2383,5 +3677,5 @@
                         ASSERT( ((r_vci_rsp_cpt == m_icache_words - 1) or
                                  p_vci_ini_rw.rerror.read() or
-                                 (r_vci_rsp_ins_error.read()&0x1)),
+                                 (r_vci_rsp_ins_error[r_vci_rsp_num_cache].read()&0x1)),
                                 "The VCI response packet for instruction miss is too short");
                         r_vci_rsp_cpt    = 0;
@@ -2389,5 +3683,5 @@
 
                     }
-                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_ins_error = true;
+                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_ins_error[r_vci_rsp_num_cache] = true;
                 }
                 break;
@@ -2396,14 +3690,14 @@
 
                 m_cost_imiss_transaction++;
-                if (p_vci_ini_rw.rspval.read() and r_vci_rsp_ack)
+                if (p_vci_ini_rw.rspval.read() and s_vci_rsp_ack)
                 {
                     ASSERT(p_vci_ini_rw.reop.read(),
                            "illegal VCI response packet for uncached instruction");
 
-                    CACHE_MISS_BUF_RSP_PUSH(i,0,(data_t)p_vci_ini_rw.rdata.read());
+                    CACHE_MISS_BUF_RSP_PUSH(i,r_vci_rsp_num_cache,0,(data_t)p_vci_ini_rw.rdata.read());
 
                     r_vci_rsp_fsm = RSP_IDLE;
 
-                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_ins_error = true;
+                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_ins_error[r_vci_rsp_num_cache] = true;
                 }
                 break;
@@ -2412,5 +3706,5 @@
 
                 m_cost_dmiss_transaction++;
-                if (p_vci_ini_rw.rspval.read() and r_vci_rsp_ack)
+                if (p_vci_ini_rw.rspval.read() and s_vci_rsp_ack)
                 {
                     PRINTF("      * <RSP> have rspval - error : %d\n",(int)p_vci_ini_rw.rerror.read());
@@ -2420,20 +3714,19 @@
                     r_vci_rsp_cpt = r_vci_rsp_cpt + 1;
 
-                    CACHE_MISS_BUF_RSP_PUSH(d,r_vci_rsp_cpt,(data_t)p_vci_ini_rw.rdata.read());
+                    CACHE_MISS_BUF_RSP_PUSH(d,r_vci_rsp_num_cache,r_vci_rsp_cpt,(data_t)p_vci_ini_rw.rdata.read());
 
                     if ( p_vci_ini_rw.reop.read() ) {
                         ASSERT( ((r_vci_rsp_cpt == m_dcache_words - 1) 
                                  or (p_vci_ini_rw.rerror.read()&0x1)
-                                 or r_vci_rsp_data_error.read()),
+                                 or r_vci_rsp_data_error[r_vci_rsp_num_cache].read()),
                                 "illegal VCI response packet for data read miss");
                         r_vci_rsp_cpt     = 0;
                         r_vci_rsp_fsm     = RSP_IDLE;
                     }
-                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error = true;
+                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error[r_vci_rsp_num_cache] = true;
                 }
                 break;
 
             case RSP_DATA_WRITE:
-
                 m_cost_write_transaction++;
                 if (p_vci_ini_rw.rspval.read())
@@ -2444,12 +3737,13 @@
                            "A VCI response packet must contain one flit for a write transaction");
                     r_vci_rsp_fsm = RSP_IDLE;
-                    bool cached = r_wbuf.completed(p_vci_ini_rw.rtrdid.read() - (1<<(vci_param::T-1)) );
+                    bool cached = r_wbuf[r_vci_rsp_num_cache]->completed(p_vci_ini_rw.rtrdid.read() - (1<<(vci_param::T-1)));
 
                     PRINTF("      * <RSP> cached : %d\n",cached);
 
                     if (not cached)
-                        r_dcache_previous_unc = false;
-
-                    if ((p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL) m_iss.setWriteBerr();
+                        r_dcache_previous_unc[r_vci_rsp_num_cache] = false;
+
+                    // FIXME : r_vci_rsp_num_cache != num_cpu ! -> pktid
+                    if ((p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL) m_iss[r_vci_rsp_num_cache]->setWriteBerr();
                 }
                 break;
@@ -2457,15 +3751,15 @@
             case RSP_DATA_UNC:
                 m_cost_unc_transaction++;
-                if (p_vci_ini_rw.rspval.read() and r_vci_rsp_ack)
+                if (p_vci_ini_rw.rspval.read() and s_vci_rsp_ack)
                 {
                     ASSERT(p_vci_ini_rw.reop.read(),
                            "illegal VCI response packet for data read uncached");
 
-                    CACHE_MISS_BUF_RSP_PUSH(d,0,(data_t)p_vci_ini_rw.rdata.read());
+                    CACHE_MISS_BUF_RSP_PUSH(d,r_vci_rsp_num_cache,0,(data_t)p_vci_ini_rw.rdata.read());
 
                     r_vci_rsp_fsm = RSP_IDLE;
-                    r_dcache_previous_unc = false;
-
-                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error = true;
+                    r_dcache_previous_unc[r_vci_rsp_num_cache] = false;
+
+                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error[r_vci_rsp_num_cache] = true;
                 }
                 break;
@@ -2473,15 +3767,15 @@
             case RSP_DATA_SC:
                 m_cost_unc_transaction++;
-                if (p_vci_ini_rw.rspval.read() and r_vci_rsp_ack)
+                if (p_vci_ini_rw.rspval.read() and s_vci_rsp_ack)
                 {
                     ASSERT(p_vci_ini_rw.reop.read(),
                            "illegal VCI response packet for data SC");
 
-                    CACHE_MISS_BUF_RSP_PUSH(d,0,(data_t)p_vci_ini_rw.rdata.read());
+                    CACHE_MISS_BUF_RSP_PUSH(d,r_vci_rsp_num_cache,0,(data_t)p_vci_ini_rw.rdata.read());
 
                     r_vci_rsp_fsm = RSP_IDLE;
-                    r_dcache_previous_unc = false;
-
-                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error = true;
+                    r_dcache_previous_unc[r_vci_rsp_num_cache] = false;
+
+                    if ( (p_vci_ini_rw.rerror.read()&0x1) != vci_param::ERR_NORMAL ) r_vci_rsp_data_error[r_vci_rsp_num_cache] = true;
                 }
                 break;
@@ -2489,5 +3783,5 @@
         } // end switch r_vci_rsp_fsm
 
-    } // end transition()
+   } // end transition()
 
     //////////////////////////////////////////////////////////////////////////////////
